// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package impl

import (
	"context"
	"property-thirdparty/impl/v1/openim"
	"property-thirdparty/impl/v1/tencent_msg"
	"property-thirdparty/impl/v1/vcode"
	"property-thirdparty/impl/v1/wxapplet"
	"property-thirdparty/impl/v1/wxmerchant"
	"property-thirdparty/pb"
	pb_v1 "property-thirdparty/pb/v1"

	"git.getensh.com/common/gopkgs/tasker/rpctasker"
	"google.golang.org/grpc"
)

// 具体实现
type Rcvr struct {
}

func Register(s *grpc.Server) {
	pb.RegisterPropertyThirdpartyServer(s, &Rcvr{})
}

func (c *Rcvr) GetVcode(ctx context.Context, req *pb_v1.GetVcodeRequest) (reply *pb_v1.GetVcodeReply, err error) {
	t1 := func() error {
		reply, err = vcode.GetVcode(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) CheckVcode(ctx context.Context, req *pb_v1.CheckVcodeRequest) (reply *pb_v1.CheckVcodeReply, err error) {
	t1 := func() error {
		reply, err = vcode.CheckVcode(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) WxAppletLoginAuth(ctx context.Context, req *pb_v1.WxAppletLoginAuthRequest) (reply *pb_v1.WxAppletLoginAuthReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxAppletLoginAuth(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) WxAppletPrepay(ctx context.Context, req *pb_v1.WxAppletPrepayRequest) (reply *pb_v1.WxAppletPrepayReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxAppletPrepay(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) WxAppletQuery(ctx context.Context, req *pb_v1.WxAppletQueryRequest) (reply *pb_v1.WxAppletQueryReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxAppletQuery(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}


func (c *Rcvr) WxPublicUnionId(ctx context.Context, req *pb_v1.WxPublicUnionIdRequest) (reply *pb_v1.WxPublicUnionIdReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxPublicUnionId(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) WxPublicMsgSend(ctx context.Context, req *pb_v1.WxPublicMsgSendRequest) (reply *pb_v1.WxPublicMsgSendReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxPublicMsgSend(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) WxPublicAddMini(ctx context.Context, req *pb_v1.WxPublicAddMiniRequest) (reply *pb_v1.WxPublicAddMiniReply, err error) {
	t1 := func() error {
		reply, err = wxapplet.WxPublicAddMini(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) TencentMsgSend(ctx context.Context, req *pb_v1.TencentMsgSendRequest) (reply *pb_v1.TencentMsgSendReply, err error) {
	t1 := func() error {
		reply, err = tencent_msg.TencentMsgSend(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}

func (c *Rcvr) OpenImRegister(ctx context.Context, req *pb_v1.OpenImRegisterRequest) (reply *pb_v1.OpenImRegisterReply, err error) {
	t1 := func() error {
		reply, err = openim.OpenImRegister(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}


// 微信特约商户进件申请
func (c *Rcvr) WxMerchantApply(ctx context.Context, req *pb_v1.WxMerchantApplyRequest) (reply *pb_v1.WxMerchantApplyReply, err error) {
	t1 := func() error {
		reply, err = wxmerchant.WxMerchantApply(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}
// 微信特约商户进件申请查询
func (c *Rcvr) WxMerchantSearch(ctx context.Context, req *pb_v1.WxMerchantSearchRequest) (reply *pb_v1.WxMerchantSearchReply, err error) {
	t1 := func() error {
		reply, err = wxmerchant.WxMerchantSearch(ctx, req)
		return err
	}

	return reply, rpctasker.Exec(ctx, t1)
}